"""
Django settings for telerad_portal_api project.

Generated by 'django-admin startproject' using Django 2.0.5.

For more information on this file, see
https://docs.djangoproject.com/en/2.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.0/ref/settings/
"""

import datetime
import importlib

import os

# This is for backward compatibility. It should be mandatory to pass an env_type
ENV_TYPE = os.environ.get('ENV_TYPE', 'local')

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY', None)

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = [
    '127.0.0.1',
    'localhost',
]

CORS_ORIGIN_ALLOW_ALL = True

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.sites',
    'rest_framework',
    'rest_framework_api_key',
    'zappa_django_utils',
    'raven.contrib.django.raven_compat',
    'storages',
    'tinymce',
    'actstream',
    'corsheaders',
    'django_extensions',
    'django_filters',
    'django_fsm',
    'organization.apps.OrganizationConfig',
    'study.apps.StudyConfig',
    'assignment.apps.AssignmentConfig',
    'report.apps.ReportConfig',
    'report_template.apps.ReportTemplateConfig',
    'users.apps.UsersConfig',
    'telerad_viewer.apps.TeleradViewerConfig',
]

SITE_ID = 1

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'telerad_portal_api.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.template.context_processors.media',
                'django.template.context_processors.static',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'telerad_portal_api.wsgi.application'

# Database settings move to environment specific settings


# Password validation
# https://docs.djangoproject.com/en/2.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.AllowAny',
        'rest_framework_api_key.permissions.HasAPIAccess',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
        'rest_framework.authentication.SessionAuthentication',
        'rest_framework.authentication.BasicAuthentication',
    ),
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.PageNumberPagination',
    'PAGE_SIZE': 10
}

JWT_AUTH = {
    'JWT_PAYLOAD_HANDLER': 'telerad_portal_api.custom_jwt.jwt_payload_handler',
    'JWT_EXPIRATION_DELTA': datetime.timedelta(hours=1),
}

TINYMCE_DEFAULT_CONFIG = {
    'theme': "simple",
    'relative_urls': False,
    'width': '50%',
    'height': 300
}

# Default facility info
DEFAULT_FACILITY_NAME = "AlemHealth"
DEFAULT_FACILITY_GUID = "007145d8-ab8c-46f2-886d-d2a175aff007"

# Sample study
SAMPLE_STUDY_CONFIG = [
    {
        'guid': '4759cf8f-a27d-4d8f-b3d1-31ab3382b807',
        'uid': '1.3.6.1.4.1.5962.99.1.2210544426.361133416.1535513901866.31.0',
        'modality': 'DX',
        'bucket': f'alemhealth-dicoms-{ENV_TYPE}',
        'zip_object_key': 'ah-connect/4759cf8f-a27d-4d8f-b3d1-31ab3382b807/1.3.6.1.4.1.5962.99.1.2210544426.361133416.1535513901866.31.0.zip',
    },
    {
        'guid': 'ae04c523-c85a-4048-916d-598d5b61617a',
        'uid': '1.3.6.1.4.1.5962.99.1.2210544426.361133416.1535513901866.4.0',
        'modality': 'CR',
        'bucket': f'alemhealth-dicoms-{ENV_TYPE}',
        'zip_object_key': 'ah-connect/ae04c523-c85a-4048-916d-598d5b61617a/1.3.6.1.4.1.5962.99.1.2210544426.361133416.1535513901866.4.0.zip',
    },
]

EMAIL_BACKEND = 'django_ses.SESBackend'
AWS_SES_REGION_NAME = 'us-west-2'
AWS_SES_REGION_ENDPOINT = 'email.us-west-2.amazonaws.com'

AWS_ACCESS_KEY_ID = None
AWS_SECRET_ACCESS_KEY = None
AWS_REGION = None

AH_CONNECT_UPSTREAM_BUCKET = None

ENALBLE_SENTRY_LOGGING = None

# Internationalization
# https://docs.djangoproject.com/en/2.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.0/howto/static-files/

STATICFILES_DIRS = [
    # os.path.join(BASE_DIR, "static"),
    os.path.join(BASE_DIR, "report/templates/"),
]

# TODO: Might need to add env variable to separate prod and dev bucket
# https://simpleisbetterthancomplex.com/tutorial/2017/08/01/how-to-setup-amazon-s3-in-a-django-project.html
# Configure Django-Storages

if os.path.isfile(BASE_DIR + f'/telerad_portal_api/{ENV_TYPE}_settings.py'):
    import_package = f'telerad_portal_api.{ENV_TYPE}_settings'
    globals().update(importlib.import_module(import_package).__dict__)

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'root': {
        'level': 'WARNING',
        'handlers': ['sentry'],
    },
    'formatters': {
        'verbose': {
            'format': '[%(asctime)s] %(levelname)s [%(pathname)s:%(lineno)d] %(message)s',
            'datefmt': "%d/%b/%Y %H:%M:%S"
        },
        'sentry': {
            'format': '%(levelname)s %(asctime)s %(module)s '
                      '%(process)d %(thread)d %(message)s'
        },
    },
    'handlers': {
        'sentry': {
            'level': 'INFO',  # To capture more than ERROR, change to WARNING, INFO, etc.
            'class': 'raven.contrib.django.raven_compat.handlers.SentryHandler',
            'tags': {
                'product': 'telerad-portal-api',
                'env-type': ENV_TYPE
            },
        },
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'verbose'
        }
    },
    'loggers': {
        '': {
            'handlers': ['console'],
            'propagate': False,
            'level': 'DEBUG',
        },
        'xhtml2pdf': {
            'handlers': ['console'],
            'level': 'INFO'
        },
        'raven': {
            'level': 'DEBUG',
            'handlers': ['console'],
            'propagate': False,
        },
        'sentry.errors': {
            'level': 'DEBUG',
            'handlers': ['console'],
            'propagate': False,
        },
    },
}
